#include <set>
#include <vector>
#include <iostream>
#include <algorithm>
using namespace std;

template<unsigned Size>
struct Elem
{
    typedef set<char> listtype;
    listtype elems[Size];
    
    typedef listtype::iterator iterator;
    typedef listtype::const_iterator const_iterator;
public:
    static inline unsigned base() { return Size; }
    
    void dump() const
    {
        for(unsigned a=0; a<Size; ++a)
        {
            if(a)cout << '*';
            listtype::const_iterator i;
            for(i=elems[a].begin(); i!=elems[a].end(); ++i)
                cout << *i;
        }
    }
    
    bool iscommon(const Elem<Size> &b, unsigned ind) const
    {
        return elems[ind] == b.elems[ind];
    }
    unsigned commoncount(const Elem<Size> &b) const
    {
        unsigned common = 0;
        for(unsigned a=0; a<Size; ++a)
            if(iscommon(b, a))
                ++common;
        return common;
    }
    
    void combine(const Elem<Size> &b)
    {
        for(unsigned ind=0; ind<Size; ++ind)
            combine(b, ind);
    }
    
    void combine(const Elem<Size> &b, unsigned ind)
    {
        listtype::const_iterator i;
        for(i=b.elems[ind].begin(); i!=b.elems[ind].end(); ++i)
            if(elems[ind].find(*i) == elems[ind].end())
                elems[ind].insert(*i);
    }
    
    bool contains(const Elem<Size> &b, unsigned ind) const
    {
        return includes(
            elems[ind].begin(), elems[ind].end()
          , 
            b.elems[ind].begin(), b.elems[ind].end()
          );
    }
    
    bool contains(const Elem<Size> &b) const
    {
        for(unsigned ind=0; ind<Size; ++ind)
            if(!contains(b, ind))return false;
        return true;
    }
    
    const Elem<Size> difference(const Elem<Size> &b)
    {
        Elem<Size> tmp;
        
        for(unsigned a=0; a<Size; ++a)
        {
            //set_difference(elems[a].begin(), elems[a].begin(),
            //               b.elems[a].begin(), b.elems[a].end(),
            //               tmp.elems[a].begin());
            
            listtype::const_iterator i;
            
            for(i=elems[a].begin(); i!=elems[a].end(); ++i)
                if(b.elems[a].find(*i) == b.elems[a].end()) tmp.elems[a].insert(*i);
            
            //for(i=b.elems[a].begin(); i!=b.elems[a].end(); ++i)
            //    if(elems[a].find(*i) == elems[a].end()) tmp.elems[a].insert(*i);
        }
        return tmp;
    }
    
    /* ABC*K with ABDFG*JK should generate C*K, as AB*K is masked out */
    void combine_to(const Elem<Size> &b)
    {
        /* Toteuta tm */
        
        /*
        (ABC*K) / (AB*K) = (C*K)  (muistaen merkint ett ab tarkoittaa a+b ja a*b tarkoittaa ab
        (ABC*DE*F) / (C*E*F) = (AB*D*F)... vai onko?
        Olisikohan tuo kenties AB*DE*F + ABC*D*F
        
        A*D*F + B*D*F + C*D*F + A*E*F + B*E*F + C*E*F = ABC*DE*F
        A*D*F + B*D*F + C*D*F + A*E*F + B*E*F         = ABC*D*F + AB*E*F tai AB*DE*F + [AB]C*D*F
        
        */
    }
    
    
};

template<unsigned Size>
class elemlist
{
    vector<Elem<Size> > elems;
public:
    void push_back(const Elem<Size> &b) { elems.push_back(b); }
    unsigned size() const { return elems.size(); }
    const Elem<Size> &operator[] (unsigned n) const { return elems[n]; }
    Elem<Size> &operator[] (unsigned n) { return elems[n]; }
    
    elemlist() { }
    elemlist(Elem<Size> &b, unsigned count=1) : elems(count, b) { }
    
    void Replace(unsigned a, const Elem<Size> &b)
    {
        elems[a] = b;
    }
    void Erase(unsigned b)
    {
        elems.erase(elems.begin() + b);
    }
    
    void dump() const
    {
        for(unsigned a=0; a<elems.size(); ++a)
        {
            if(a)cout << " + ";
            elems[a].dump();
        }
    }
    
    bool achieves(const elemlist<Size> &b) const
    {
        for(unsigned a=0; a<b.elems.size(); ++a)
        {
            for(unsigned c=0; c<elems.size(); ++c)
                if(elems[c].contains(b.elems[a]))goto Ok;
            return false;
        Ok: ;
        }
        return true;
    }

    bool achieves(const elemlist<Size> &b, unsigned without) const
    {
        for(unsigned a=0; a<b.elems.size(); ++a)
        {
            for(unsigned c=0; c<elems.size(); ++c)
            {
                if(c == without)continue;
                if(elems[c].contains(b.elems[a]))goto Ok;
            }
            return false;
        Ok: ;
        }
        return true;
    }

    void combine()
    {
        Retry:
        for(unsigned a=0; a<elems.size(); ++a)
        {
            /* Retry-label could be placed here too.
             * It would not cause different results, just group them differently.
             */
            for(unsigned b=a+1; b<elems.size(); ++b)
            {
                unsigned c = elems[a].commoncount(elems[b]);
                if(c == Size - 1)
                {
                    elems[a].combine(elems[b]);
                    elems.erase(elems.begin() + b);
                    goto Retry;
                }
            }
        }
    }
    
    void expand()
    {
        vector<Elem<Size> > result;
        
        for(unsigned a=0; a<elems.size(); ++a)
        {
            Elem<Size> &e = elems[a];
            Elem<Size>::const_iterator ind[Size];
            for(unsigned b=0; b<Size; ++b)
            {
                ind[b] = e.elems[b].begin();
                if(ind[b] == e.elems[b].end())
                    goto Next;
            }
            for(;;)
            {
                Elem<Size> tmp;
                for(unsigned c=0; c<Size; ++c)
                    tmp.elems[c].insert(*(ind[c]));
                result.push_back(tmp);
                unsigned b = 0;
            Re:
                if(++ind[b] != e.elems[b].end())continue;
                ind[b] = e.elems[b].begin(); if(++b==Size)break;
                goto Re;
            }
        Next: ;
        }
        elems.swap(result);
    }
    
    void join()
    {
        /* Tm poistaa ylimrisi valintoja laittamalla toistensa plle niit.
         *
         * Esimerkki:
         *    CE*G  + BCD*HI + E*I
         * -> CE*GI + BCD*HI
         *
         * Menetelm: E*I:st kaikki paitsi yksi elementti sisltyy CE*G:hen.
         *            Siisp katsotaan voidaanko *I list CE*G:hen.
         *            Tt varten muodostetaan lista CE*GI:st ja katsotaan
         *            mahtuvatko kaikki mainitut elementit alkuperiseen listaan.
         *
         */
    Retry:
        for(unsigned a=0; a<elems.size(); ++a)
        {
            {elemlist<Size> tmp(elems[a]);
            tmp.expand();
            if(achieves(tmp, a))
            {
                cout << "Deleting redundant: "; elems[a].dump(); cout << endl;
                Erase(a);
                goto Retry;
            }}
            for(unsigned c=0; c<elems.size(); ++c)
            {
                if(c!=a)
                {
                    Elem<Size> tmp = elems[c].difference(elems[a]);
                    Elem<Size> tmp2 = elems[c];
                    tmp2.combine(elems[a]);
                    elemlist<Size> comb(tmp2);
                    comb.expand();
                    
                    if(achieves(comb))
                    {
                        cout << "Joining "; elems[c].dump();
                        cout << " to "; elems[a].dump();
                        cout << " as "; tmp2.dump(); cout << endl;
                        Replace(a, tmp2);
                        Erase(c);
                        goto Retry;
                    }
                }
            }
        }
    }
    
    void overlap()
    {
        /* Tm laajentaa valinnat menemn toistensa plle. */
        for(unsigned a=0; a<elems.size(); ++a)
            for(unsigned b=a+1; b<elems.size(); ++b)
            {
                bool same[Size]; unsigned samecount = 0;
                for(unsigned c=0; c<Size; ++c)
                {
                    same[c] = elems[b].contains(elems[a], c);
                    if(same[c])++samecount;
                }
                if(samecount == Size-1)
                {
                    unsigned lack=0;
                    cout << "Combining "; elems[a].dump(); cout << " from "; elems[b].dump(); cout << endl;
                    for(unsigned c=0; c<Size; ++c)if(!same[c]){lack=c;break;}
                    elems[a].combine(elems[b], lack);
                }
            }
    }
};

static void BuildDemo()
{
    static const char X[5] =
         "ABCDE";
    static const char Y[4] =
       "F"
       "G"
       "H"
       "I";
#if 1
    static const char T[(sizeof X) * (sizeof Y)] =
         "..X.X"
         "XXX.X"
         "XXXXX"
         "XXXXX";
    static const char goal[] = "CE*FGHI + ABCE*GHI + ABCDE*HI";
#endif
#if 0
    static const char T[(sizeof X) * (sizeof Y)] =
         "....."
         "..X.X"
         ".XXX."
         ".XXXX";
    static const char goal[] = "CE*GI + BCD*HI";
#endif
#if 0
    static const char T[(sizeof X) * (sizeof Y)] =
         "X..X."
         "X.X.X"
         "X.XXX"
         "X.XXX";
    static const char goal[] = "AD*FGHI + ACE*GHI";
#endif
    
    static const unsigned level=2;
    elemlist<level> elems;
    
    cout << "Input:\n\t ";
    for(unsigned x=0; x<(sizeof X); ++x)
        cout << X[x];
    cout << endl;
    
    /* Build it */
    for(unsigned y=0; y<(sizeof Y); ++y)
    {
        cout << '\t' << Y[y];
        for(unsigned x=0; x<(sizeof X); ++x)
        {
            cout << T[y*(sizeof X)+x];
            if(T[y*(sizeof X)+x] == 'X')
            {
                Elem<level> tmp;
                tmp.elems[0].insert(X[x]);
                tmp.elems[1].insert(Y[y]);
                elems.push_back(tmp);
            }
        }
        cout << endl;
    }
    cout << endl;
    
    cout << "= "; 
    elems.dump();
    cout << endl;
    
    /* At this point, we have a list of A*B*C -type elements. Singular. */
    
    elems.combine();

    cout << "Combined: ";
    elems.dump();
    cout << endl;
    
    /* Now we have them compiled in arithmetical way.
     * But they can be combined logically too.
     */
    
    elems.overlap();
    
    cout << "Overlapped: ";
    elems.dump();
    cout << endl;
    
    elems.join();

    cout << "Joined: ";
    elems.dump();
    cout << endl;
    
    cout << endl; elems.dump();
            cout << "        = result\n";
    cout << goal << "        = goal\n";
}

int main(void)
{
    BuildDemo();
    
    return 0;
}
